=== sysdeps/s390/s390-32/multiarch/Makefile ===
ifeq ($(subdir),string)
sysdep_routines += memset memset-s390 memcpy memcpy-s390 \
		   memcmp memcmp-s390
endif
