=== debian/changelog ===
glibc (2.28-10.lnd.32) unstable; urgency=medium

  * Add patches:
    0001-glibc-2.28-sysvipc-Fix-SEM_STAT_ANY-kernel-argument-.patch
    0002-glibc-2.28-align-stack-in-clone-from-github.patch
    0003-glibc-2.28-Fix-tst-cancel21.c-to-suit-kernel-struct-.patch
    0004-glibc-2.28-add-vdso-support-for-gettimeofday.patch

 --  <caiyinyu@loongson-pc>  Sat, 02 Apr 2022 10:20:54 +0800

glibc (2.28-10.lnd.30) unstable; urgency=medium

  * Add LoongArch support.

 --  <caiyinyu@loongson.cn>  Tue, 07 Dec 2021 16:21:39 +0800

glibc (2.28-10) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix infinite loop in pldd.  Closes: #913929.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 01 May 2019 19:24:19 +0200

glibc (2.28-9) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix heap-based buffer over-read in regular-expression matching
      (CVE-2019-9169).  Closes: #924612.
    - Add entry for the new Japanese era to the ja_JP locale.  Closes:
      #927914.

  [ Adam Conrad ]
  * debian/patches/arm/unsubmitted-ldso-abi-check.diff: Fix rtld segv in
    dl_open() introduced via merge with upstream at 2.28 (LP: #1821677)

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 25 Apr 2019 21:12:03 +0200

glibc (2.28-8) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch.
  * Update Danish debconf translation, by Joe Hansen.  Closes: #923055.

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/libpthread_sigs.diff: Enable patch to restore
    per-thread signal distribution, lost on upgrading to 2.28. Fixes go.
  * debian/patches/hurd-i386/git-renameat2.diff: New patch, fixes renameat2,
    now used by coreutils.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 27 Feb 2019 21:56:01 -0800

glibc (2.28-7) unstable; urgency=medium

  * debian/patches/hurd-i386/local-no-bootstrap-fs-access.diff: Refresh.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 09 Feb 2019 18:34:27 +0100

glibc (2.28-6) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-AT_EMPTY_PATH.diff: New patch, fixes qt's
    file size query.
  * debian/patches/hurd-i386/git-altstack.diff: New patch, fixes altstack
    initial state.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix a buffer overflow in string/memory functions on x32 (CVE-2019-6488).
    - Reject IP addresses with trailing characters (CVE-2016-10739).  Closes:
      #920047.
    - Fix wrong return value for memcmp on amd64 and x32 due to mishandling
      of most significant bit (CVE-2019-7309).
  * Update Russian debconf translation, by Lev Lamberov.  Closes:
    #921165.
  * debian/patches/any/local-ldso-disable-hwcap.diff: only check for
    /etc/ld.so.nohwcap on alpha, hurd-i386 and i386. Based on a patch from
    Josh Triplett.  Closes: #908928.
  * debian/patches/any/git-libio-stdout-putc.diff: fix puts and putchar output
    with change stdout pointer.  Closes: #761300.
  * debhelper.in/locales.bug-presubj: drop obsolete file, the dependency
    mechanism for locales has been changes a lot of time ago.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 05 Feb 2019 19:55:42 +0100

glibc (2.28-5) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/script.in/nsscheck.sh: fix a typo s/samaba/samba/. Closes:
    #909047.
  * debian/debhelper.in/libc.postrm: suidmanager is long gone, remove support
    for it.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - debian/patches/arm/submitted-gcc-8-kernel-assisted-atomics.diff:
      upstreamed.
    - any/submitted-workaround-math-errno-gcc-bug.diff: upstreamed.
  * debian/control.in/libc: fix nocache Breaks, set it to (<< 1.1-1~). Closes:
    #918583.
  * debian/patches/localedata/git-en_US-date_fmt.diff: backport from upstream
    support for date_fmt for the en_US locale. Closes: #877900.

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-libpthread_setpshared.diff: New patch to
    avoid letting packages use setpshared.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 12 Jan 2019 18:50:25 +0100

glibc (2.28-4) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/testsuite-xfail-debian.mk: whitelist math/test-fenv on riscv64.
    This failure is also due to a kernel bug.
  * debian/sysdeps/riscv64.mk: increase TIMEOUTFACTOR to 100 on riscv64.
  * debian/local/manpages/*: remove manpages that are not installed in the
    binary packages.
  * debian/local/manpages/po/de.po: update German manpages translations, by
    Helge Kreutzmann. Closes: #877434.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - debian/patches/any/submitted-sigaction-sa-restorer.diff: upstreamed.
  * debian/testsuite-xfail-debian.mk: whitelist tests that sometimes fail in
    a riscv64 QEMU VM, but not on a HiFive Unleashed board.
  * debian/patches/submitted-gcc-8-kernel-assisted-atomics.diff: fix kernel
    assisted atomics on armel with GCC 8.
  * debian/control.in/main, debian/sysdeps/armel.mk: build with GCC 8 on
    armel.
  * debian/patches/any/submitted-workaround-math-errno-gcc-bug.diff:
    workaround GCC bug BZ #88576 / Debian #917115 by not using -fmath-errno
    outside of libm.  Closes: #916779.
  * debian/patches/riscv64/git-thread-debugging.diff: fix thread debugging
    in gdb on riscv64.

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: whitelist failing new tests on hurd.
  * debian/patches/hurd-i386/git-fcntl64.diff: Fix 64bit implementation.
  * debian/patches/hurd-i386/tg-context_functions.diff: Update from topgit.
  * debian/patches/hurd-i386/tg-sysvshm.diff: Update from topgit.
  * debian/patches/hurd-i386/tg-magic-pid.diff: rename to git-magic-pid.diff.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 29 Dec 2018 11:04:27 +0100


